package polymorph;

public class Main
{

  private static final long UPTO = 500 * 1000 * 1000;
  private static final int MAX=10;
  private static long[] times;

  @SuppressWarnings("empty-statement")
  public static void main(String[] args)
  {
    int value=0;
    
    times = new long[MAX];
    System.out.print("\nInline:\t\t");
    for (int j = 0; j < MAX; j++)
    {
      long time = System.currentTimeMillis();
      for (int i = 0; i < UPTO; i++)
      {
        value=i;
      }
      time = System.currentTimeMillis() - time;
      times[j] = time;
      System.out.print(time + " ");
      System.out.flush();
    }
    printStat();

    times = new long[MAX];
    System.out.print("Simple:\t\t");
    for (int j = 0; j < MAX; j++)
    {
      long time = System.currentTimeMillis();
      polymorph.simple.Use use = new polymorph.simple.Use(new polymorph.simple.Used());
      for (int i = 0; i < UPTO; i++)
      {
        value=use.run(i);
      }
      time = System.currentTimeMillis() - time;
      times[j] = time;
      System.out.print(time + " ");
      System.out.flush();
    }
    printStat();

    times = new long[MAX];
    System.out.print("One implement:\t");
    for (int j = 0; j < MAX; j++)
    {
      long time = System.currentTimeMillis();
      polymorph.one_implement.Use use = new polymorph.one_implement.Use(new polymorph.one_implement.Used());
      for (int i = 0; i < UPTO; i++)
      {
        value=use.run(i);
      }
      time = System.currentTimeMillis() - time;
      times[j] = time;
      System.out.print(time + " ");
      System.out.flush();
    }
    printStat();

    times = new long[MAX];
    System.out.print("Two implement:\t");
    for (int j = 0; j < MAX; j++)
    {
      long time = System.currentTimeMillis();
      polymorph.two_implement.Use use = new polymorph.two_implement.Use(new polymorph.two_implement.Used1());
      for (int i = 0; i < UPTO; i++)
      {
        value=use.run(i);
      }
      time = System.currentTimeMillis() - time;
      times[j] = time;
      System.out.print(time + " ");
      System.out.flush();
    }
    printStat();

    times = new long[MAX];
    System.out.print("One abstract:\t");
    for (int j = 0; j < MAX; j++)
    {
      long time = System.currentTimeMillis();
      polymorph.one_abstract.Use use = new polymorph.one_abstract.Use(new polymorph.one_abstract.Used());
      for (int i = 0; i < UPTO; i++)
      {
        value=use.run(i);
      }
      time = System.currentTimeMillis() - time;
      times[j] = time;
      System.out.print(time + " ");
      System.out.flush();
    }
    printStat();

    times = new long[MAX];
    System.out.print("Two abstract:\t");
    for (int j = 0; j < MAX; j++)
    {
      long time = System.currentTimeMillis();
      polymorph.two_abstract.Use use = new polymorph.two_abstract.Use(new polymorph.two_abstract.Used2());
      for (int i = 0; i < UPTO; i++)
      {
        value=use.run(i);
      }
      time = System.currentTimeMillis() - time;
      times[j] = time;
      System.out.print(time + " ");
      System.out.flush();
    }
    printStat();

    times = new long[MAX];
    System.out.print("Override:\t");
    for (int j = 0; j < MAX; j++)
    {
      long time = System.currentTimeMillis();
      polymorph.abstract_override.Use use = new polymorph.abstract_override.Use(new polymorph.abstract_override.Used());
      for (int i = 0; i < UPTO; i++)
      {
        value=use.run(i);
      }
      time = System.currentTimeMillis() - time;
      times[j] = time;
      System.out.print(time + " ");
      System.out.flush();
    }
    printStat();
    
  /*
  A1 a = new A1(new B1());
  time = System.currentTimeMillis();
  for (int i = 0; i < UPTO; i++)
  {
  a.run();
  }
  time = System.currentTimeMillis() - time;
  System.out.print(time + "\t");
  System.out.flush();
  A2 a2 = new A2(new C2());
  time = System.currentTimeMillis();
  for (int i = 0; i < UPTO; i++)
  {
  a2.run();
  }
  time = System.currentTimeMillis() - time;
  System.out.print(time + "\t");
  System.out.flush();
  A3 a3 = new A3(new C3());
  time = System.currentTimeMillis();
  for (int i = 0; i < UPTO; i++)
  {
  a3.run();
  }
  time = System.currentTimeMillis() - time;
  System.out.print(time + "\t");
  System.out.flush();
  A3 a3_c3 = new A3(new C3());
  A3 a3_d3 = new A3(new D3());
  time = System.currentTimeMillis();
  for (int i = 0,  upto = UPTO / 2; i < upto; i++)
  {
  a3_c3.run();
  a3_d3.run();
  }
  time = System.currentTimeMillis() - time;
  System.out.print(time + "\t");
  System.out.flush();
  A4 a4_c4 = new A4(new C4());
  A4 a4_d4 = new A4(new D4());
  A4 a4_e4 = new A4(new E4());
  A4 a4_f4 = new A4(new F4());
  time = System.currentTimeMillis();
  for (int i = 0,  upto = UPTO / 4; i < upto; i++)
  {
  a4_c4.run();
  a4_d4.run();
  a4_e4.run();
  a4_f4.run();
  }
  time = System.currentTimeMillis() - time;
  System.out.println(time);
  }*/
  }

  public static void printStat()
  {
    long min = Long.MAX_VALUE;
    long max = Long.MIN_VALUE;
    long avg = 0;

    for (int j = 0; j < MAX; j++)
    {
      if (times[j] < min)
      {
        min = times[j];
      }
      if (times[j] > max)
      {
        max = times[j];
      }
      avg += times[j];
    }
    avg = avg / MAX;

    System.out.print("\nMin:" + min + " ");
    System.out.print("Max:" + max + " ");
    System.out.println("Avg:" + avg);
  }
}
